/* rec_hfind.c -- find a record in a hashed file */
#include "rec_io.h"

long rec_hfind(fd, keybuf, buf, cmpfn, hashfn)
	rec_fd fd;			/* hashed file */
	data_ptr keybuf;	/* record key to find */
	data_ptr buf;		/* buffer for found record */
	int (*cmpfn)();		/* record key comparison function */
	long (*hashfn)();	/* hash lookup function */
	{
	long nrecs;			/* number of records in file */
	long ntry;
	long i;

	nrecs = rec_nrecs(fd);
	i = (*hashfn)(keybuf);
	for (ntry = 0; ntry < nrecs; ++ntry)
		{
		if (!rec_get(fd, buf, i))
			return (REC_ERROR);				/* i/o error during rec_get */
		if (*(char *)buf == REC_AVAIL)		/* examine first byte of buf */
			return (REC_NOT_FOUND);
		if (*(char *)buf == REC_OCCUP)
			{
			if ((*cmpfn)(keybuf, buf) == 0)
					return (i);
			}
		i = IMOD(i + 1, nrecs);
		}
	return (REC_FULL);
	}
